diff -u update-dpkg-list~ update-dpkg-list
--- update-dpkg-list~	2022-01-13 20:52:49.875888185 -0500
+++ update-dpkg-list	2022-01-13 21:41:42.053617442 -0500
@@ -4,6 +4,7 @@
 use warnings;
 use IPC::Open2;
 use File::Basename;
+use POSIX qw(:sys_wait_h);
 
 my $program = basename($0);
 
@@ -59,14 +60,20 @@
   # apt-cache doesn't read stdin, so we have to use xargs to make sure we
   # never exceed the bash command line limit.
   my $pid = open2(\*ACS, \*XARGS, 'xargs -0r apt-cache show');
+  my $pid2 = fork();
 
-  print XARGS join("\0",@unknown);
-  close(XARGS);
+  if ($pid2 == 0) {
+    print XARGS join("\0",@unknown);
+    exit(0);
+  } else {
+    close(XARGS);
+  }
 
   while (<ACS>) {
     parse_pkg('ACS',$_);
   };
   close(ACS);
+  waitpid($pid2, WNOHANG);
 };
 
 my $dlist = '/var/lib/dlocate/dpkg-list';
